#ifndef _ATAPIO_H
#define _ATAPIO_H

#include <types.h>

#define ATA_MASTER	0
#define ATA_SLAVE	1

#define ATA_IO_BASE 	0x1f0

#define ATA_DATA	ATA_IO_BASE+0
#define ATA_ERROR	ATA_IO_BASE+1
#define ATA_FEATURES	ATA_IO_BASE+1
#define ATA_SECTOR_CNT	ATA_IO_BASE+2
#define ATA_SECTOR_NUM	ATA_IO_BASE+3
#define ATA_LBA_LOW	ATA_IO_BASE+3
#define ATA_CYL_LOW	ATA_IO_BASE+4
#define ATA_LBA_MID	ATA_IO_BASE+4
#define ATA_CYL_HIGH	ATA_IO_BASE+5
#define ATA_LBA_HIGH	ATA_IO_BASE+5
#define ATA_DRIVE_SEL	ATA_IO_BASE+6
#define ATA_STATUS	ATA_IO_BASE+7
#define ATA_COMMAND	ATA_IO_BASE+7

/* this seems weird but whatever */
#define ATA_CMD_BASE	0x3f6

#define ATA_ALT_STATUS	ATA_CMD_BASE+0
#define ATA_CONTROL	ATA_CMD_BASE+0
#define ATA_DRIVE_ADDR	ATA_CMD_BASE+1

#define ATA_STATUS_ERR	(1 << 0)
#define ATA_STATUS_IDX	(1 << 1)
#define ATA_STATUS_CORR (1 << 2)
#define ATA_STATUS_DRQ	(1 << 3)
#define ATA_STATUS_SRV	(1 << 4)
#define ATA_STATUS_DF	(1 << 5)
#define ATA_STATUS_RDY	(1 << 6)
#define ATA_STATUS_BSY	(1 << 7)

#define ATA_SECTOR_SIZE	512


uint32_t atapio_identify(uint8_t drive, uint16_t* buf);
uint32_t ata_info(uint8_t drive);
uint32_t ata_read_sectors(uint8_t drive, uint32_t lba, uint8_t count, uint16_t* buf);

#endif