#include <types.h>
#include <lib.h>
#include <Devices/keyboard.h>

#include "terminal.h"

int32_t terminal_read(int32_t fd, void* buf, int32_t nbytes){
	int bytes_read = 0;
	while (bytes_read < nbytes) {
		uint8_t key = keyboard_get_key();
		putc(key);
		if (key == '\n') {
			*((uint8_t*)buf + bytes_read) = '\0';
			break;
		}

		*((uint8_t*)buf + bytes_read) = key;
		bytes_read++;
	}
	return 0;
}

int32_t terminal_write(int32_t fd, const void* buf, int32_t nbytes)
{
	int i;
	for (i = 0; i < nbytes; i++) {
		putc(*(uint8_t*)(buf + i));
	}
	return 0;
}

int32_t terminal_open(const uint8_t* filename)
{
	return -1;
}

int32_t terminal_close(int32_t fd)
{
	return -1;
}
