#include <types.h>
#include <lib.h>
#include <Syscalls/execute.h>
#include <Syscalls/syscalls.h>
#include <Filesystem/ext2.h>

#include "file.h"
#include "filedescriptor.h"

static fops_t file_ops = {file_open, file_close, file_read, file_write};

int32_t file_read(int32_t fd, void* buf, int32_t len)
{
	return -1;
}

int32_t file_write(int32_t fd, const void* buf, int32_t len)
{
	return -1;
}

int32_t file_open(const uint8_t* name)
{
	printf("file_open\n");

	int32_t fd = find_new_fd();
	pcb_t* pcb = get_pcb_ptr();
	pcb->file_desc_array[fd].file_pos = 0;
	pcb->file_desc_array[fd].flags |= FD_INUSE;
	pcb->file_desc_array[fd].file_ops = &file_ops;
	pcb->file_desc_array[fd].inode = ext2_parse_path_to_inode_num((int8_t*)name);

	return fd;
}

int32_t file_close(int32_t fd)
{
	return -1;
}
