#ifndef _FILEDESCRIPTOR_H
#define _FILEDESCRIPTOR_H

#include <types.h>

#define FD_INUSE 1

/* file operations struct */
typedef struct fops_t {
	int32_t (*open)(const uint8_t* filename);
	int32_t (*close)(int32_t fd);
	int32_t (*read)(int32_t fd, void* buf, int32_t nbytes);
	int32_t (*write)(int32_t fd, const void* buf, int32_t nbytes);
} fops_t;

/* file descriptors struct */
typedef struct file_desc_t {
	fops_t* file_ops;
	uint32_t inode;
	uint32_t file_pos;
	uint32_t flags;
} file_desc_t;

int32_t find_new_fd();

#endif