#ifndef _MBR_H
#define _MBR_H

#include <types.h>

typedef struct chs_address {
	union {
		struct {
			uint8_t head;
			uint8_t sector_cylinder;
			uint8_t cylinder;
		} __attribute__ ((packed));
	};
} chs_address_t;

typedef struct partition {
	union {
		struct {
			uint8_t status;
			chs_address_t chs_start;
			uint8_t type;
			chs_address_t chs_end;
			uint32_t lba_start;
			uint32_t sector_count;
		} __attribute__ ((packed));
	};
} partition_t;

typedef struct mbr {
	union {
		uint16_t data[256];
		struct {
			uint8_t bootstrap_code[446];
			partition_t partitions[4];
			uint8_t boot_signature[2];
		};
	};
} mbr_t;

#endif