/* code for initializing the IDT and attaching interrupt handlers */

#ifndef _INTERRUPTS_H
#define _INTERRUPTS_H

#include <types.h>



typedef struct irq_callback {
	uint32_t (*handler)();
	struct irq_callback* next;
} irq_callback_t;

uint32_t interrupts_init();

uint32_t attach_interrupt(int num, int dpl, irq_callback_t* callback);

uint32_t handle_irq(uint32_t num);

#endif