#ifndef _SYSCALLS_H
#define _SYSCALLS_H

#include <types.h>

#define SYS_INVALID 0
#define SYS_READ 1
#define SYS_WRITE 2
#define SYS_OPEN 3
#define SYS_CLOSE 4
#define SYS_EXEC 5
#define SYS_EXIT 6

int32_t sys_read(int32_t fd, void* buf, int32_t len);
int32_t sys_write(int32_t fd, const void* buf, int32_t len);
int32_t sys_open(uint8_t* name);
int32_t sys_close(int32_t fd);
int32_t sys_exec(uint8_t* name);
int32_t sys_exit(uint32_t status);

#endif
