#ifndef _HEAP_H
#define _HEAP_H

#include <types.h>

#define HEAP_START 0x8800000
#define HEAP_PHYS 0x7000000

#define HEAP_INUSE 1

typedef struct heap_descriptor {
	uint32_t size;
	uint32_t flags;
	struct heap_descriptor* prev;
	struct heap_descriptor* next;
} heap_descriptor_t;

typedef struct heap_header {
	uint32_t size;
	void* next_page;
	heap_descriptor_t* start;
} heap_header_t;

uint32_t heap_create(int pid);
uint32_t heap_destroy();
void* heap_alloc(uint32_t size);
uint32_t heap_free(void* addr);

#endif