#define ASM 1
#include "x86_desc.h"

.text

.globl ldt_size, tss_size
.globl gdt_desc, ldt_desc, tss_desc
.globl tss, tss_desc_ptr, ldt, ldt_desc_ptr
.globl gdt, gdt_desc_ptr
.globl idt, idt_desc_ptr
.global page_directory, page_table

.align 4

tss_size:
	.long tss_bottom - tss - 1

ldt_size:
	.long ldt_bottom - ldt - 1

	.word 0 /* padding */
ldt_desc:
	.word KERNEL_LDT
	.long ldt

	.align 4
tss:
_tss:
	.rept 104
	.byte 0
	.endr
tss_bottom:

gdt_desc:
	.word gdt_bottom - gdt - 1
	.long gdt

	.align 16
gdt:
_gdt:

	# First GDT entry cannot be used
	.quad 0

	# NULL entry
	.quad 0
	
gdt_ptr:
	# Set up an entry for kernel CS
	.quad 0x00CF9A000000FFFF

	# Set up an entry for kernel DS
	.quad 0x00CF92000000FFFF

	# Set up an entry for user CS
	.quad 0x00CFFA000000FFFF

	# Set up an entry for user DS
	.quad 0x00CFF2000000FFFF

tss_desc_ptr:
	.quad 0

ldt_desc_ptr:
	.quad 0

gdt_bottom:

	.align 16

ldt:
	.rept 4
	.quad 0
	.endr
ldt_bottom:

.align 4
	.word 0 # Padding
idt_desc_ptr:
	.word idt_bottom - idt - 1
	.long idt

	.align 16
idt:
_idt:
	.rept IDT_SIZE
	.quad 0
	.endr

idt_bottom:

.align 4096
page_directory:
	.rept 1024
	.long 0
	.endr

.align 4096
page_table:
	.rept 1024
	.long 0
	.endr

