# based on the one from SerenitiyOS, but cut down a bin

die() {
    echo "die: $*"
    exit 1
}

if [ "$(id -u)" != 0 ]; then
    exec sudo -E -- "$0" "$@" || die "this script needs to run as root"
else
    : "${SUDO_UID:=0}" "${SUDO_GID:=0}"
fi

printf "creating loopback device... "
dev=$(losetup --find --partscan --show summer_img)
if [ -z "$dev" ]; then
    die "couldn't mount loopback device"
fi
echo "loopback device is at ${dev}"

cleanup() {
    if [ -d mnt ]; then
        printf "unmounting filesystem... "
        umount mnt || ( sleep 1 && sync && umount mnt )
        rmdir mnt
        echo "done"
    fi

    if [ -e "${dev}" ]; then
        printf "cleaning up loopback device... "
        losetup -d "${dev}"
        echo "done"
    fi
}
trap cleanup EXIT

partition_number="p1"

printf "mounting filesystem... "
mkdir -p mnt
mount "${dev}${partition_number}" mnt/ || die "couldn't mount filesystem"
echo "done"

# move root filesystem, this can be its own script when bigger.
rsync -av --delete-after fsdir/Home/ mnt/Home
rsync -av --delete-after fsdir/Programs/ mnt/Programs

mkdir -p mnt/boot/grub
mkdir -p mnt/modules			# just hack this module in real quick
cp media/sunset.bmp mnt/modules
cp img mnt/boot/img
#cp -aT fsdir/* mnt/

cp grub.cfg mnt/boot/grub/grub.cfg

rm -rf isodir
echo "done"